from argparse import ArgumentParser

from wharfrat.wharf_rat import WharfRat
from wharfrat.interface import issue


def create_parser():

    parser = ArgumentParser(description='Wharf-Rat is a simple tool to '
                            'convert .yml config files into docker '
                            'commands')
    parser.add_argument('-f', dest='filename', help='Specify the .yml file')
    parser.add_argument('command', help='the command to run, such as "run"')
    parser.add_argument('task', help='the name of the task')
    parser.add_argument('ctx', nargs='*', help='key value pairs to override, '
                                               'like "a=b')

    return parser


def get_command(args):

    commands = {
        'run': WharfRat.run
    }
    return commands[args.command]


def main(args=None):

    parser = create_parser()
    _args = parser.parse_args(args)
    translater = WharfRat.build(_args)
    command = get_command(_args)
    result = command(translater, _args.task)
    for item in result:
        issue(item)
