import os
import yaml

from wharfrat.container import Container
from wharfrat.task import Task


class WharfRat():

    def __init__(self, data, directory=os.getcwd(), context={}):

        self.tasks = {x: Task(x, data[x], context=context) for x in data}

    @classmethod
    def build(cls, args):
        filename = 'wharfrat.yml'
        if args.filename:
            filename = args.filename
        ctx = getattr(args, 'ctx', [])
        context = {ln.split('=')[0]: ln.split('=')[1] for ln in ctx}
        return cls(cls._load(filename), context=context)

    @staticmethod
    def _load(filename):
        with open(filename, 'r') as f:
            try:
                data = yaml.load(f)
            except yaml.parser.ParserError:
                print "Invalid Yaml file!"
                raise
            return data

    def run(self, task):

        return self.tasks[task].run()
